package sun.java2d.opengl;

import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.SurfaceType;
import java.lang.ref.WeakReference;
import sun.java2d.loops.Blit;

class OGLGeneralBlit extends Blit
{
    private final Blit performop;
    private WeakReference srcTmp;
    
    OGLGeneralBlit(SurfaceType dsttype, CompositeType comptype, Blit performop) {
        super(SurfaceType.Any, comptype, dsttype);
        this.performop = performop;
    }
    
    @Override
    public synchronized void Blit(SurfaceData convert, SurfaceData surfaceData, Composite composite, Region region, int srcX, int srcY, int n, int n2, int w, int h) {
        Blit fromCache = Blit.getFromCache(convert.getSurfaceType(), CompositeType.SrcNoEa, SurfaceType.IntArgbPre);
        SurfaceData dstData = null;
        if (this.srcTmp != null) {
            dstData = (SurfaceData)this.srcTmp.get();
        }
        convert = GraphicsPrimitive.convertFrom(fromCache, convert, srcX, srcY, w, h, dstData, 3);
        this.performop.Blit(convert, surfaceData, composite, region, 0, 0, n, n2, w, h);
        if (convert != dstData) {
            this.srcTmp = new WeakReference(convert);
        }
    }
}
